<?xml version="1.0" encoding="utf-8" ?>
<xml>
<?php
function cat2idx($cat)
{
	$cats = amule_get_categories();
	$result = 0;
	foreach($cats as $i => $c) {
		if ( $cat == $c) $result = $i;
	}
	return $result;
}

if ($_SESSION["guest_login"] == 0) {
	if ( $HTTP_GET_VARS["ed2klink"] != "" ) {
		$link = $HTTP_GET_VARS["ed2klink"];
		$target_cat = $HTTP_GET_VARS["selectcat"];
		$target_cat_idx = cat2idx($target_cat);
	 	if ( strlen($link) > 0 ) {
			amule_do_ed2k_download_cmd($link, $target_cat_idx);
		}
	}

	if ( $HTTP_GET_VARS["command"] != "" ) {
		foreach ( $HTTP_GET_VARS as $name => $val) {
			// this is file checkboxes
			if ( (strlen($name) == 32) and ($val == "on") ) {
				//var_dump($name);
				amule_do_download_cmd($name, $HTTP_GET_VARS["command"]);
			}
		}
		//
		// check "filter-by-status" settings
		//
		if ( $HTTP_GET_VARS["command"] == "filter") {
			$_SESSION["filter_status"] = $HTTP_GET_VARS["status"];
			$_SESSION["filter_cat"] = $HTTP_GET_VARS["category"];
		}
	}
}

function CastToXBytes($size)
{
	if ( $size < 1024 ) {
		$result = $size . " bytes";
	} elseif ( $size < 1048576 ) {
		$result = ($size / 1024.0) . "KB";
	} elseif ( $size < 1073741824 ) {
		$result = ($size / 1048576.0) . "MB";
	} else {
		$result = ($size / 1073741824.0) . "GB";
	}
	return $result;
}

function StatusString($file)
{
	if ( $file->status == 7 ) {
		return "Paused";
	} elseif ( $file->src_count_xfer > 0 ) {
		return "Downloading";
	} else {
		return "Waiting";
	}
}

function PrioString($file)
{
	$prionames = array(0 => "Low", 1 => "Normal", 2 => "High",
		3 => "Very high", 4 => "Very low", 5=> "Auto", 6 => "Powershare");
	$result = $prionames[$file->prio];
	if ( $file->prio_auto == 1) {
		$result = $result . "(auto)";
	}
	return $result;
}

//
// declare it here, before any function reffered it in "global"
//
$sort_order;$sort_reverse;

function my_cmp($a, $b)
{
	global $sort_order, $sort_reverse;
	
	switch ( $sort_order) {
		case "size": $result = $a->size > $b->size; break;
		case "size_done": $result = $a->size_done > $b->size_done; break;
		case "progress": $result = (((float)$a->size_done)/((float)$a->size)) > (((float)$b->size_done)/((float)$b->size)); break;
		case "name": $result = $a->name > $b->name; break;
		case "speed": $result = $a->speed > $b->speed; break;
		case "scrcount": $result = $a->src_count > $b->src_count; break;
		case "status": $result = StatusString($a) > StatusString($b); break;
		case "prio": $result = PrioString($a) > PrioString($b); break;
	}

	if ( $sort_reverse ) {
		$result = !$result;
	}
	//var_dump($sort_reverse);
	return $result;
}

if ( $_SESSION["filter_status"] == "") $_SESSION["filter_status"] = "all";
if ( $_SESSION["filter_cat"] == "") $_SESSION["filter_cat"] = "all";

echo "<filter_status><![CDATA[", $_SESSION["filter_status"], "]]></filter_status>\n";

$downloads = amule_load_vars("downloads");

$sort_order = $HTTP_GET_VARS["sort"];

if ( $sort_order == "" ) {
	$sort_order = $_SESSION["download_sort"];
} else {
	if ( $_SESSION["download_sort_reverse"] == "" ) {
		$_SESSION["download_sort_reverse"] = 0;
	} else {
		if ( $HTTP_GET_VARS["sort"] != '') {
			$_SESSION["download_sort_reverse"] = !$_SESSION["download_sort_reverse"];
		}
	}
}
//var_dump($_SESSION);
$sort_reverse = $_SESSION["download_sort_reverse"];
if ( $sort_order != "" ) {
	$_SESSION["download_sort"] = $sort_order;
	usort(&$downloads, "my_cmp");
}

//
// Prepare categories index array
print "<categories>\n";
$cats = amule_get_categories();
foreach($cats as $i => $c) {
	echo "\t<category><![CDATA[", $c,"]]></category>\n";
	$cat_idx[$c] = $i;
}
echo "\t<selected><![CDATA[", $_SESSION["filter_cat"], "]]></selected>\n";
print "</categories>\n";

foreach ($downloads as $file) {
	$filter_status_result = ($_SESSION["filter_status"] == "all") or
		($_SESSION["filter_status"] == StatusString($file));
		
	$filter_cat_result = ($_SESSION["filter_cat"] == "all") or
		($cat_idx[ $_SESSION["filter_cat"] ] == $file->category);

	if ( $filter_status_result and $filter_cat_result) {
		print "<dl_file>\n";
		echo "\t<hash><![CDATA[", $file->hash, "]]></hash>\n";
		echo "\t<short_name><![CDATA[", $file->short_name, "]]></short_name>\n";
		echo "\t<size><![CDATA[", CastToXBytes($file->size), "]]></size>\n";
		echo "\t<size_done><![CDATA[", CastToXBytes($file->size_done), "&nbsp;(",
			((float)$file->size_done*100)/((float)$file->size), "%)]]></size_done>\n";
		echo "\t<src_count><![CDATA[";
		if ( $file->src_count_not_curr != 0 ) {
			echo $file->src_count - $file->src_count_not_curr, "&nbsp;/&nbsp;";
		}
		echo $file->src_count, "&nbsp;(", $file->src_count_xfer, ")";
		if ( $file->src_count_a4af != 0 ) {
			echo "+ ", $file->src_count_a4af;
		}
		echo "]]></src_count>\n";
		echo "\t<status_string><![CDATA[", StatusString($file), "]]></status_string>\n";
		echo "\t<speed><![CDATA[", ($file->speed > 0) ? (CastToXBytes($file->speed) . "/s") : "-", "]]></speed>\n";
		echo "\t<prio><![CDATA[", PrioString($file), "]]></prio>\n";
		print "</dl_file>\n";
	}
}
	
$uploads = amule_load_vars("uploads");
foreach ($uploads as $file) {
	echo "<ul_file>\n";
	echo "\t<short_name><![CDATA[", $file->short_name, "]]></short_name>\n";
	echo "\t<user_name><![CDATA[", $file->user_name, "]]></user_name>\n";
	echo "\t<xfer_up><![CDATA[", CastToXBytes($file->xfer_up), "]]></xfer_up>\n";
	echo "\t<xfer_down><![CDATA[", CastToXBytes($file->xfer_down), "]]></xfer_down>\n";
	echo "\t<speed><![CDATA[", ($file->xfer_speed > 0) ? (CastToXBytes($file->xfer_speed) . "/s") : "-", "]]></speed>\n";
	echo "</ul_file>\n";
}

$stats = amule_get_stats();
echo "<status>\n";
echo "\t<id><![CDATA[", $stats["id"], "]]></id>\n";
echo "\t<serv_name><![CDATA[", $stats["serv_name"], "]]></serv_name>\n";
echo "\t<serv_addr><![CDATA[", $stats["serv_addr"], " ]]></serv_addr>\n";
echo "\t<string><![CDATA[";
	if ( $stats["id"] == 0 ) {
		echo "Not connected";
	} elseif ( $stats["id"] == 0xffffffff ) {
		echo "Connecting ...";
	} else {
		echo "Connected with ", (($stats["id"] < 16777216) ? "low" : "high"), " ID to ",
			$stats["serv_name"], "  ", $stats["serv_addr"];
	}
echo " ]]></string>\n";
echo "</status>\n";
?>
</xml>
