<?xml version="1.0" encoding="utf-8" ?>
<xml>
	<?php
	// apply new options before proceeding
	//var_dump($HTTP_GET_VARS);
	if ( ($HTTP_GET_VARS["command"] == "prefs") && ($_SESSION["guest_login"] == 0) ) {
		$file_opts = array("check_free_space", "extract_metadata", 
			"ich_en","aich_trust", "preview_prio","save_sources", "resume_same_cat",
			"min_free_space", "new_files_paused", "alloc_full", "alloc_full_chunks",
			"new_files_auto_dl_prio", "new_files_auto_ul_prio"
		);
		$conn_opts = array("max_line_up_cap","max_up_limit",
			"max_line_down_cap","max_down_limit", "slot_alloc", 
			"tcp_port","udp_dis","max_file_src","max_conn_total","autoconn_en");
		$webserver_opts = array("use_gzip", "autorefresh_time");
		
		$all_opts;
		foreach ($conn_opts as $i) {
			$curr_value = $HTTP_GET_VARS[$i];
			if ( $curr_value == "on") $curr_value = 1;
			if ( $curr_value == "") $curr_value = 0;
			
			$all_opts["connection"][$i] = $curr_value;
		}
		foreach ($file_opts as $i) {
			$curr_value = $HTTP_GET_VARS[$i];
			if ( $curr_value == "on") $curr_value = 1;
			if ( $curr_value == "") $curr_value = 0;
			
			$all_opts["files"][$i] = $curr_value;
		}
		foreach ($webserver_opts as $i) {
			$curr_value = $HTTP_GET_VARS[$i];
			if ( $curr_value == "on") $curr_value = 1;
			if ( $curr_value == "") $curr_value = 0;
			
			$all_opts["webserver"][$i] = $curr_value;
		}
		//var_dump($all_opts);
		amule_set_options($all_opts);
	}
	$opts = amule_get_options();
	//var_dump($opts);
	$opt_groups = array("connection", "files", "webserver");
	//var_dump($opt_groups);
	echo "<prefs>\n";
	foreach ($opt_groups as $group) {
		echo "\t<",$group,">\n";
		$curr_opts = $opts[$group];
		//var_dump($curr_opts);
		foreach ($curr_opts as $opt_name => $opt_val) {
			echo "\t\t<",$opt_name,"><![CDATA[";
			echo $opt_val;
			echo "]]></",$opt_name,">\n";
		}
		echo "\t</",$group,">\n";
	}
	echo "</prefs>\n";
?>
<?php
$stats = amule_get_stats();
echo "<status>\n";
echo "\t<id><![CDATA[", $stats["id"], "]]></id>\n";
echo "\t<serv_name><![CDATA[", $stats["serv_name"], "]]></serv_name>\n";
echo "\t<serv_addr><![CDATA[", $stats["serv_addr"], " ]]></serv_addr>\n";
echo "\t<string><![CDATA[";
	if ( $stats["id"] == 0 ) {
		echo "Not connected";
	} elseif ( $stats["id"] == 0xffffffff ) {
		echo "Connecting ...";
	} else {
		echo "Connected with ", (($stats["id"] < 16777216) ? "low" : "high"), " ID to ",
			$stats["serv_name"], "  ", $stats["serv_addr"];
	}
echo " ]]></string>\n";
echo "</status>\n";
?>
</xml>
