<?xml version="1.0" encoding="utf-8" ?>
<xml>
<?php
function CastToXBytes($size)
{
	if ( $size < 1024 ) {
		$result = $size . " bytes";
	} elseif ( $size < 1048576 ) {
		$result = ($size / 1024.0) . "KB";
	} elseif ( $size < 1073741824 ) {
		$result = ($size / 1048576.0) . "MB";
	} else {
		$result = ($size / 1073741824.0) . "GB";
	}
	return $result;
}

//
// declare it here, before any function reffered it in "global"
//
$sort_order;$sort_reverse;

function my_cmp($a, $b)
{
	global $sort_order, $sort_reverse;
	
	switch ( $sort_order) {
		case "size": $result = $a->size > $b->size; break;
		case "name": $result = $a->name > $b->name; break;
		case "sources": $result = $a->sources > $b->sources; break;
	}

	if ( $sort_reverse ) {
		$result = !$result;
	}

	return $result;
}

function str2mult($str)
{
	$result = 1;
	switch($str) {
		case "Byte":	$result = 1; break;
		case "KByte":	$result = 1024; break;		
		case "MByte":	$result = 1012*1024; break;
		case "GByte":	$result = 1012*1024*1024; break;
	}
	return $result;
}

function cat2idx($cat)
{
	$cats = amule_get_categories();
	$result = 0;
	foreach($cats as $i => $c) {
		if ( $cat == $c) $result = $i;
	}
	return $result;
}

if ($_SESSION["guest_login"] == 0) {
	
	if ( $HTTP_GET_VARS["command"] == "search") {
		$search_type = -1;
		switch($HTTP_GET_VARS["searchtype"]) {
			case "Local": $search_type = 0; break;
			case "Global": $search_type = 1; break;
			case "Kad": $search_type = 2; break;
		}
		$min_size = $HTTP_GET_VARS["minsize"] == "" ? 0 : $HTTP_GET_VARS["minsize"];
		$max_size = $HTTP_GET_VARS["maxsize"] == "" ? 0 : $HTTP_GET_VARS["maxsize"];

		$min_size *= str2mult($HTTP_GET_VARS["minsizeu"]);
		$max_size *= str2mult($HTTP_GET_VARS["maxsizeu"]);
		
		amule_do_search_start_cmd($HTTP_GET_VARS["searchval"],
			//$HTTP_GET_VARS["ext"], $HTTP_GET_VARS["filetype"],
			"", "",
			$search_type, $HTTP_GET_VARS["avail"], $min_size, $max_size);
	} elseif ( $HTTP_GET_VARS["command"] == "download") {
		foreach ( $HTTP_GET_VARS as $name => $val) {
			// this is file checkboxes
			if ( (strlen($name) == 32) and ($val == "on") ) {
				$cat = $HTTP_GET_VARS["targetcat"];
				$cat_idx = cat2idx($cat);
				amule_do_search_download_cmd($name, $cat_idx);
			}
		}
	} else {
	}
}
$search = amule_load_vars("searchresult");

$sort_order = $HTTP_GET_VARS["sort"];

if ( $sort_order == "" ) {
	$sort_order = $_SESSION["search_sort"];
} else {
	if ( $_SESSION["search_sort_reverse"] == "" ) {
		$_SESSION["search_sort_reverse"] = 0;
	} else {
		$_SESSION["search_sort_reverse"] = !$_SESSION["search_sort_reverse"];
	}
}

$sort_reverse = $_SESSION["search_sort_reverse"];
if ( $sort_order != "" ) {
	$_SESSION["search_sort"] = $sort_order;
	usort(&$search, "my_cmp");
}

foreach ($search as $file) {
	print "<search_file>\n";
	echo "\t<hash><![CDATA[", $file->hash, "]]></hash>\n";
	echo "\t<short_name><![CDATA[", $file->short_name, "]]></short_name>\n";
	echo "\t<size><![CDATA[", CastToXBytes($file->size), "]]></size>\n";
	echo "\t<sources><![CDATA[", $file->sources, "]]></sources>\n";
	print "</search_file>\n";
}

?>
<?php
	$stats = amule_get_stats();
	echo "<status>\n";
	echo "\t<id><![CDATA[", $stats["id"], "]]></id>\n";
	echo "\t<serv_name><![CDATA[", $stats["serv_name"], "]]></serv_name>\n";
	echo "\t<serv_addr><![CDATA[", $stats["serv_addr"], " ]]></serv_addr>\n";
	echo "\t<string><![CDATA[";
		if ( $stats["id"] == 0 ) {
			echo "Not connected";
		} elseif ( $stats["id"] == 0xffffffff ) {
			echo "Connecting ...";
		} else {
			echo "Connected with ", (($stats["id"] < 16777216) ? "low" : "high"), " ID to ",
				$stats["serv_name"], "  ", $stats["serv_addr"];
		}
	echo " ]]></string>\n";
	echo "</status>\n";
?>
<?php
	print "<categories>\n";
	$cats = amule_get_categories();
	foreach($cats as $i => $c) {
		echo "\t<category><![CDATA[", $c,"]]></category>\n";
		$cat_idx[$c] = $i;
	}
	echo "\t<selected><![CDATA[", $_SESSION["filter_cat"], "]]></selected>\n";
	print "</categories>\n";
?>
</xml>
