function SearchSection() {
	timer.set_delay(10);
	this.set_section();
	this.init_size();
	this.refresh_address = "ajax-search.php";
	this.selected_file = new Array();
	this.selected_cat = ""
	this.last_selects_update = 0;
	reload()
}

SearchSection.prototype.set_section = function() {
	var output = '<div id="search_dest_cat" style="float: right;">Waiting for server reply</div>';
	output += '<form action="#" onsubmit="javascript:Section.search(); return false;" id="search_form">';
	output += '	<input name="searchval" type="text" id="searchval" size="75">';
	output += '	<input name="Search" type="submit" value="Search" onclick="javascript:Section.search();">';
	output += '	<br />';
	output += '	<label>Min size</label>';
	output += '	&nbsp;';
	output += '	<input name="minsize" type="text" id="minsize" size="5">';
	output += '	<select name="minsizeu" id="minsizeu">';
	output += '	    <option>Byte</option>';
	output += '	    <option>KByte</option>';
	output += '	    <option selected>MByte</option>';
	output += '	    <option>GByte</option>';
	output += '	</select>';
	output += '	<label>Max size</label>';
	output += '	&nbsp;';
	output += '	<input name="maxsize" type="text" id="maxsize" size="5">';
	output += '	<select name="maxsizeu" id="maxsizeu">';
	output += '	      <option>Byte</option>';
	output += '	      <option>KByte</option>';
	output += '	      <option selected>MByte</option>';
	output += '	      <option>GByte</option>';
	output += '	</select>';
	output += '	<label>Availability</label>';
	output += '	<input name="avail" type="text" id="avail" size="6">';
	output += '	<label>Search type </label>';
	output += '	<select name="searchtype" id="searchtype">';
	output += '	  <option selected>Local</option>';
	output += '	  <option>Global</option>';
	output += '	  <option>Kad</option>';
	output += '	</select>';
	output += '</form>';
	
	output += '<div id="search_table"><div style="text-align: left">Waiting for server reply...</div></div>';
	output += '<div id="search_download" class="textline">';
	output += ' <form name="formlink" method="post" action="index.php">';
	output += ' <div id="ed2klinkarea"><input type="text" id="ed2klink" name="ed2klink" size="70">';
	output += ' <input type="submit" name="Submit" value="Download link">';
  output += ' <input type="hidden" name="section" value="transfert">';
	output += ' <input type="hidden" name="targetcat" value="Tous" id="ed2klink_targetcat"></div>';
	output += ' <a href="javascript:Section.mass_download()"><img src="l_download.gif">Download all checked</a></form>';
	output += '</div>';
	document.getElementById("section").innerHTML = output;
}

// initialise div sizes (search_table div)
SearchSection.prototype.init_size = function() {
	var used_height = 0;
	used_height += document.getElementById("search_form").offsetHeight;
	used_height += document.getElementById("search_download").offsetHeight;
	

	var resized_div = document.getElementById("search_table");
	resized_div.style.height = document.getElementById("section").offsetHeight - used_height;
}

// show right menu on a file
SearchSection.prototype.rightmenu_show = function(e, hash) {
	var rightmenu = document.getElementById("rightmenu");
	var output = '<div style="text-align: right; padding: 0px;"><img src="rm_close.gif" onclick="Section.rightmenu_hide()"/></div>';
	output += '<div class="rightmenuaction" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" onclick="Section.download(\''+hash+'\')"><img src="l_download.gif" />Download</div>';
	
	if (!e) var e = window.event;
	if (e.pageX || e.pageY) 	{
		MouseX = e.pageX;
		MouseY = e.pageY;
	}
	else if (e.clientX || e.clientY) 	{
		MouseX = e.clientX + document.body.scrollLeft
			+ document.documentElement.scrollLeft;
		MouseY = e.clientY + document.body.scrollTop
			+ document.documentElement.scrollTop;
	}
	
	rightmenu.innerHTML = output;
	rightmenu.style.display = "block";
	rightmenu.style.top=MouseY;
	rightmenu.style.left=MouseX;
	
	return false;
}

// hide right menu on a file
SearchSection.prototype.rightmenu_hide = function() {
	document.getElementById('rightmenu').style.display = 'none';
}

// transmit to server 'short by' query
SearchSection.prototype.shortby = function(criteria) {
	var address = this.refresh_address +"?sort="+criteria;
	reload(address);
}

// Disable: urlencode problem, so use of POST
//SearchSection.prototype.ed2klink_download = function(input) {
//	this.rightmenu_hide();
//	var address = this.refresh_address +"?targetcat="+this.selected_cat +"&ed2klink="+input.value;
//	input.value = "";
//	alert(address);
//	reload(address);
//}

// on dowload request on a file
SearchSection.prototype.download = function(hash) {
	this.rightmenu_hide();
	var address = this.refresh_address +"?command=download&targetcat="+this.selected_cat +"&"+hash+"=on";

	reload(address);
}

// On click on download all selected files
SearchSection.prototype.mass_download = function() {
	this.rightmenu_hide();
	var address = this.refresh_address +"?command=download&targetcat="+this.selected_cat;
	for(var hash in this.selected_file) {
		if(this.selected_file[hash] == true) {
			address += "&"+hash+"=on"
		}
	}
	reload(address);
}

//On check on a checkbox of search file, memorise checked for refresh()
SearchSection.prototype.check_file = function(hash) {
	if(this.selected_file[hash] == true) {
		this.selected_file[hash] = false;
	} else {
		this.selected_file[hash] = true;
	}
}

// On select a category in select
SearchSection.prototype.select_cat = function(select) {
	this.selected_cat=select.options[select.selectedIndex].value;
	document.getElementById("ed2klink_targetcat").value = this.selected_cat;
}

// On submit search form
SearchSection.prototype.search = function() {
	this.rightmenu_hide();
	var address = this.refresh_address +"?command=search";
	address += "&searchval=" + document.getElementById('searchval').value;
	address += "&searchtype=" + document.getElementById('searchtype').value;
	address += "&minsize=" + document.getElementById('minsize').value;
	address += "&minsizeu=" + document.getElementById('minsizeu').value;
	address += "&maxsize=" + document.getElementById('maxsize').value;
	address += "&maxsizeu=" + document.getElementById('maxsizeu').value;
//	address += "&filetype=" + document.getElementById('filetype').value;
	reload(address);
}

// On refresh action
SearchSection.prototype.refresh = function(responseXML) {
	this.make_search_table(responseXML);
	this.make_cat(responseXML);
}

// On refresh search table of all found files
SearchSection.prototype.make_search_table = function(responseXML) {
	var file_list = responseXML.documentElement.getElementsByTagName("search_file");
	var output = '\n<table><tr>\n';
	output += '\t<th class="checkbox" width="22" scope="col">&nbsp;</th>';
	output += '\t<th nowrap scope="col" onclick="javascript:Section.shortby(\'name\')" class="name"><div class="name" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Filename ('+file_list.length+')</div></th>\n';
	output += '\t<th nowrap scope="col" onclick="javascript:Section.shortby(\'size\')" class="size"><div class="size" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Size</div></th>\n';
	output += '\t<th nowrap scope="col" onclick="javascript:Section.shortby(\'sources\')" class="sources"><div class="sources" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Sources</div></th>\n';
	output += '</tr>\n';
	
	this.response_nb = file_list.length;
	// For each file
	for(i=0;i<file_list.length; i++) {
		var file = file_list.item(i);
		var hash = file.getElementsByTagName('hash').item(0).firstChild.data;
		if(this.selected_file[hash] != true) {
			this.selected_file[hash] = false;
		}
		
		output += '<tr oncontextmenu="Section.rightmenu_show(event, \''+ hash +'\')">\n';
		output += '\t<td><input type="checkbox" name="'+ hash +'" ';
		output += this.selected_file[hash]?'checked ':'';
		output += 'onclick=\'Section.check_file("'+hash+'")\' /></td>\n';
		output += '\t<td class="name" nowrap>'+ replace(file.getElementsByTagName('short_name').item(0).firstChild.data, " ", "&nbsp;") +'</td>\n';
		output += '\t<td>'+ file.getElementsByTagName('size').item(0).firstChild.data +'</td>\n';
		output += '\t<td>'+ file.getElementsByTagName('sources').item(0).firstChild.data +'</td>\n';
		output += '</tr>\n';
	}
	output += '</table>\n';

	document.getElementById("search_table").innerHTML = output;
}

// Draw the select of all categories
SearchSection.prototype.make_cat = function(responseXML) {
	var currentDate = new Date();
	var currentTime = currentDate.getTime();
	
	//only update all 30s
	if(this.last_selects_update + 30000 < currentTime ) {
		this.last_selects_update = currentTime;
		
		var categories = responseXML.documentElement.getElementsByTagName("categories").item(0);
		var cat_list = categories.getElementsByTagName("category");
	//	var cat_selected = categories.getElementsByTagName("selected").item(0).firstChild.data;
		
		var output = 'Download to category: <select name="selcategory" id="selcategory" onchange="Section.select_cat(this)">\n';
		
		if(this.selected_cat == "") {
			this.selected_cat = cat_list.item(0).firstChild.data;
		}
		// For each category
		for(i=0;i<cat_list.length; i++) {
			var category = cat_list.item(i).firstChild.data;
			output += (this.selected_cat == category) ? '\t<option selected ' : '<option ';
			output += 'value="'+ category +'">' 
			output += category;
			output += '</option>\n';
		}
		output += '</select>\n';

		document.getElementById("search_dest_cat").innerHTML = output;
	}
}