function str_printable(src) {
	return replace(src, " ", "&nbsp;");
}

function replace(string, pattern, replacement) {
// Recursively replaces pattern with replacement in string
    if ((string.length == 0) || (pattern.length == 0)) {
    	//Invalid call
    	return string;
    }

    var pos = string.indexOf(pattern);
    
    if( ((!pos) && (pattern != string.substring(0,pattern.length))) || (pos == -1) ) {
    	//stop recursion 
    	return string;
    }
		
		//replace
    var result = string.substring(0,pos) + replacement;

    if (pos+pattern.length < string.length) {
    	//Recurse
      result += replace(string.substring(pos+pattern.length,string.length),pattern,replacement);
    }
    return result;
}