<?xml version="1.0" encoding="utf-8" ?>
<xml>
	<stats_tree>
<?php
//Prefer $key_index to $key because $key can contains specials chars, in localised version
$key_idx=0;

// for dealing with global vars in recursive function...
function inc_key_idx() {
	global $key_idx;
	$key_idx++;
}

function get_key_idx() {
	global $key_idx;
	echo $key_idx;
}

function print_ident($i)
{
	while($i != 0) {
		echo "\t";
		$i--;
	}
}

function print_item($it, $ident)
{
	print_ident($ident);
	echo "<item><![CDATA[", $it, "]]></item>\n";
}

function print_folder($key, &$arr, $ident)
{
	inc_key_idx();
	print_ident($ident);
	echo "<category idx=\"", get_key_idx() , "\" label=\"", $key ,"\">\n";
	foreach ($arr as $k => $v) {
		if ( count(&$v) ) {
			print_folder($k, $v, $ident+1);
		} else {
			print_item($k, $ident+1);
		}
	}
	print_ident($ident);
	echo "</category>\n";
}

	$stattree = amule_load_vars("stats_tree");

	foreach ($stattree as $k => $v) {
		if ( count(&$v) ) {
			print_folder($k, $v, $ident+1);
		} else {
			print_item($k, $ident+1);
		}
	}
?>
	</stats_tree>
<?php
	$stats = amule_get_stats();
	echo "<status>\n";
	echo "\t<id><![CDATA[", $stats["id"], "]]></id>\n";
	echo "\t<serv_name><![CDATA[", $stats["serv_name"], "]]></serv_name>\n";
	echo "\t<serv_addr><![CDATA[", $stats["serv_addr"], " ]]></serv_addr>\n";
	echo "\t<string><![CDATA[";
		if ( $stats["id"] == 0 ) {
			echo "Not connected";
		} elseif ( $stats["id"] == 0xffffffff ) {
			echo "Connecting ...";
		} else {
			echo "Connected with ", (($stats["id"] < 16777216) ? "low" : "high"), " ID to ",
				$stats["serv_name"], "  ", $stats["serv_addr"];
		}
	echo " ]]></string>\n";
	echo "</status>\n";
?>
</xml>
