// Layout fonctions //

var current_section = "transfert"; //currently openned section

//Init height of section div with scree height
function init_size() {
	var last_section = current_section;

	open_tab("none");
	
	var used_height = 2;
	used_height += document.getElementById("menu").offsetHeight;
	used_height += document.getElementById("status").offsetHeight;
	
	var section = document.getElementById("section");
	section.style.height = document.body.clientHeight - used_height;
	
	open_tab(last_section);
}
var Section = null;
//change section

function open_tab(section) {
	current_section = section;
	if(section == "kad") {
		current_section = 'kad';
		Section = new KadSection();
	}
	if(section == "transfert") {
		current_section = "transfert";
		Section = new Transfert();
	}
	if(section == "servers") {
		current_section = 'servers';
		Section = new ServersSection();
	}
	if(section == "search") {
		current_section = "search";
		Section = new SearchSection();
	}
	if(section == "shared") {
		current_section = 'shared';
		Section = new SharedSection();
	}
	if(section == "stats") {
		current_section = 'stats';
		Section = new StatsSection();
	}
	if(section == "settings") {
		current_section = 'settings';
		Section = new PrefsSection();
	}
	if(section == "none") {
		current_section = "none";
		Section = new NoneSection();
	}
	reload();
}

function getHTTPObject() {
	var xmlhttp = false;

	if (window.XMLHttpRequest) {
		//Mozilla, firefox, IE 7
		xmlhttp = new XMLHttpRequest();

		// Safari workaround
		if (xmlhttp.overrideMimeType) {
			xmlhttp.overrideMimeType("text/xml");
		}
	}
	else {
		if (window.ActiveXObject) {
			try {
				// IE
				xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
			}
			catch (e) {
				try {
					// another IE
					xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
				}
				catch (e) {
					alert("XMLHTTPRequest (AJAX) not available in your browser");
				}
			}
		}
	}
	return xmlhttp;
}

//Main XMLHttpRequest object
var xmlhttp = getHTTPObject(); /* Create object */

function reload(addr)
{	
	//function to reload data from servers
	//addr should be specify for sending data throught GET
	xmlhttp = getHTTPObject(); // Create object

	xmlhttp.onreadystatechange=function () {
//		try {
				if (xmlhttp.readyState == 4) // 4 : state "complete"
			{
				if (xmlhttp.status == 200) // 200 : code HTTP OK
				{
					var responseXML = xmlhttp.responseXML;
	
					if (responseXML.documentElement == null) {
						// override content-type for IE
						responseXML = new ActiveXObject("Microsoft.XMLDOM");
						responseXML.loadXML(xmlhttp.responseText);
					}
	
					Section.refresh(responseXML);
	
					//Update status area
					var status_msg = responseXML.documentElement.getElementsByTagName("status").item(0).getElementsByTagName('string').item(0).firstChild.data;
					
					document.getElementById("status").innerHTML = status_msg + "<img src='rm_close.gif' onclick=\"document.getElementById('status').style.display = 'none'; init_size();\">";
					window.defaultStatus = status_msg;
				}
			}
//		} catch(e) { alert("Exception : " + e) }
	}
	if(!addr || addr == "") addr = Section.refresh_address;
	xmlhttp.open("GET", addr, true);
	xmlhttp.send(null);
		
}

// Main loop
var timer = new Timer();
