function ServersSection() {
	timer.set_delay(10);
	this.set_section();
	this.refresh_address = "ajax-servers.php";
	this.init_size();
}

ServersSection.prototype.set_section = function() {
	document.getElementById("section").innerHTML = '<div id="servers_table">Waiting for server reply...</div>';
}

// initialise div sizes (servers_table div)
ServersSection.prototype.init_size = function() {
	document.getElementById("servers_table").style.height = document.getElementById("section").offsetHeight;
}

// On refresh action
ServersSection.prototype.refresh = function(responseXML) {
	this.make_servers_table(responseXML);
}

// On refresh search table of all found files
//ServersSection.prototype.search_table_col = new Arrray(
//	new Array("id": "connect",			"label": "",						"sortable": false),
//	new Array("id": "name",					"label": "Name",				"sortable": true),
//	new Array("id": "description",	"label": "Description",	"sortable": true),
//	new Array("id": "address",			"label": "Address",			"sortable": true),
//	new Array("id": "users",				"label": "Users",				"sortable": true),
//	new Array("id": "maxusers",			"label": "Max Users",		"sortable": true),
//	new Array("id": "sources",			"label": "Sources",			"sortable": true)
//);
//	var template = '<th nowrap scope="col" onclick="javascript:Section.shortby(\'[ID]\')" class="[ID]"><div class="[ID]" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >[LABEL]</div></th>\n';
//	"<server>";
//	"	<ip></ip>";
//	"	<port></port>";
//	"	<name></name>";
//	"	<desc></desc>";
//	"	<addr></addr>";
//	"	<users></users>";
//	"	<maxusers></maxusers>";
//	"	<files></files>";
//	"</server>";
	
ServersSection.prototype.make_servers_table = function(responseXML) {
	var servers_list = responseXML.documentElement.getElementsByTagName("server");
	var output = '\n<table><tr>\n';
//	output += '\t<th class="checkbox" width="22" scope="col">&nbsp;</th>';
	output += '\t<th nowrap scope="col" onclick="javascript:Section.shortby(\'name\')" class="name"><div class="name" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Name ('+servers_list.length+')</div></th>\n';
	output += '\t<th nowrap scope="col" onclick="javascript:Section.shortby(\'desc\')" class="description"><div class="description" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Description</div></th>\n';
	output += '\t<th nowrap scope="col" onclick="javascript:Section.shortby(\'addr\')" class="address"><div class="address" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Address</div></th>\n';
	output += '\t<th nowrap scope="col" onclick="javascript:Section.shortby(\'users\')" class="users"><div class="users" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Users</div></th>\n';
	output += '\t<th nowrap scope="col" onclick="javascript:Section.shortby(\'maxusers\')" class="maxusers"><div class="maxusers" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Max Users</div></th>\n';
	output += '\t<th nowrap scope="col" onclick="javascript:Section.shortby(\'files\')" class="files"><div class="files" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Files</div></th>\n';
	output += '</tr>\n';
				
	// For each file
	for(i=0;i<servers_list.length; i++) {
		var server = servers_list.item(i);
		var id = "&ip=" + server.getElementsByTagName('ip').item(0).firstChild.data;
		id += "&port="  + server.getElementsByTagName('port').item(0).firstChild.data;
		
		output += '<tr oncontextmenu="Section.rightmenu_show(event, \''+ id +'\')">\n';
//		output += '\t<td><img src="connect.gif" width="16" height="16" border="0"><img src="cancel.gif" width="16" height="16" border="0"></td>\n';
		output += '\t<td class="name" nowrap>'+ str_printable(server.getElementsByTagName('name').item(0).firstChild.data) +'</td>\n';
		output += '\t<td class="desc" nowrap>'+ str_printable(server.getElementsByTagName('desc').item(0).firstChild.data) +'</td>\n';
		output += '\t<td class="addr" nowrap>'+ server.getElementsByTagName('addr').item(0).firstChild.data +'</td>\n';
		output += '\t<td class="users" nowrap>'+ server.getElementsByTagName('users').item(0).firstChild.data +'</td>\n';
		output += '\t<td class="maxusers" nowrap>'+ server.getElementsByTagName('maxusers').item(0).firstChild.data +'</td>\n';
		output += '\t<td class="files" nowrap>'+ server.getElementsByTagName('files').item(0).firstChild.data +'</td>\n';
		output += '</tr>\n';
	}
	output += '</table>\n';

	document.getElementById("servers_table").innerHTML = output;
}

// show right menu on a file
ServersSection.prototype.rightmenu_show = function(e, id) {
	var rightmenu = document.getElementById("rightmenu");
	var output = '<div style="text-align: right; padding: 0px;"><img src="rm_close.gif" onclick="Section.rightmenu_hide()"/></div>';
	output += '<div class="rightmenuaction" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" onclick="Section.action(\'connect\', \''+id+'\')"><img src="connect.gif" />Connect</div>';
	output += '<div class="rightmenuaction" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" onclick="Section.action(\'remove\', \''+id+'\')"><img src="cancel.gif" />Remove</div>';
	
	if (!e) var e = window.event;
	if (e.pageX || e.pageY) 	{
		MouseX = e.pageX;
		MouseY = e.pageY;
	}
	else if (e.clientX || e.clientY) 	{
		MouseX = e.clientX + document.body.scrollLeft
			+ document.documentElement.scrollLeft;
		MouseY = e.clientY + document.body.scrollTop
			+ document.documentElement.scrollTop;
	}
	
	rightmenu.innerHTML = output;
	rightmenu.style.display = "block";
	rightmenu.style.top=MouseY;
	rightmenu.style.left=MouseX;
	
	return false;
}

// hide right menu on a file
ServersSection.prototype.rightmenu_hide = function() {
	document.getElementById('rightmenu').style.display = 'none';
}

// transmit to server action query
ServersSection.prototype.action = function(action, id) {
	var address = this.refresh_address + "?cmd="+action+id;
	this.rightmenu_hide();
//	alert(address);
	reload(address);
}

// transmit to server 'short by' query
ServersSection.prototype.shortby = function(criteria) {
	var address = this.refresh_address + "?sort="+criteria;
	reload(address);
}