function SharedSection() {
	timer.set_delay(10);
	this.set_section();
	this.init_size();
	this.refresh_address = "ajax-shared.php";
	this.selected_file = new Array();
	this.selected_cat = ""
	this.last_selects_update = 0;
	reload()
}

SharedSection.prototype.set_section = function() {
	var output = '<div id="shared_table">Waiting for server reply</div>';
	output += '<div id="shared_form">';
//	output += ' <input type="button" value="Change all selected to" onclick="Section.mass_action(\'setprio\')">';
//	output += ' Change all selected prio to: <select name="setprio" id="setprio"><option selected>Select prio</option><option>Low</option><option>Normal</option><option>High</option></select>';
	output += ' <input type="button" value="Change all selected priority Up" onclick="Section.mass_action(\'prioup\')">';
	output += ' <input type="button" value="Change all selected priority Down" onclick="Section.mass_action(\'priodown\')">';
	output += ' <input type="button" value="Reload" onclick="Section.mass_action(\'reload\')">';
	output += '</div>';

	document.getElementById("section").innerHTML = output;
}

// initialise div sizes (search_table div)
SharedSection.prototype.init_size = function() {
	var used_height = 0;
	used_height += document.getElementById("shared_form").offsetHeight;

	var resized_div = document.getElementById("shared_table");
	resized_div.style.height = document.getElementById("section").offsetHeight - used_height;
}

// show right menu on a file
SharedSection.prototype.rightmenu_show = function(e, hash) {
	var rightmenu = document.getElementById("rightmenu");
	var output = '<div style="text-align: right; padding: 0px;"><img src="rm_close.gif" onclick="Section.rightmenu_hide()"/></div>';
	output += '<div class="rightmenuaction" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" onclick="Section.action(\'prioup\',\''+hash+'\')"><img src="l_up.gif" />Priority Up</div>';
	output += '<div class="rightmenuaction" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" onclick="Section.action(\'priodown\',\''+hash+'\')"><img src="l_down.gif" />Priority Down</div>';

	if (!e) var e = window.event;
	if (e.pageX || e.pageY) 	{
		MouseX = e.pageX;
		MouseY = e.pageY;
	}
	else if (e.clientX || e.clientY) 	{
		MouseX = e.clientX + document.body.scrollLeft
			+ document.documentElement.scrollLeft;
		MouseY = e.clientY + document.body.scrollTop
			+ document.documentElement.scrollTop;
	}
	
	rightmenu.innerHTML = output;
	rightmenu.style.display = "block";
	rightmenu.style.top=MouseY;
	rightmenu.style.left=MouseX;
	
	return false;
}

// hide right menu on a file
SharedSection.prototype.rightmenu_hide = function() {
	document.getElementById('rightmenu').style.display = 'none';
}

// transmit to server 'short by' query
SharedSection.prototype.shortby = function(criteria) {
	var address = this.refresh_address + "?sort="+criteria;
	reload(address);
}


// on dowload request on a file
SharedSection.prototype.action = function(action, hash) {
	this.rightmenu_hide();
	var address = this.refresh_address +"?command="+action+"&"+hash+"=on";

	reload(address);
}

// On click on download all selected files
SharedSection.prototype.mass_action = function(action) {
	this.rightmenu_hide();
//	var setprio = document.getElementById('setprio')
	var address = this.refresh_address +"?command="+action;//+"&="+setprio.options[setprio.selectedIndex].value;
	for(var hash in this.selected_file) {
		if(this.selected_file[hash] == true) {
			address += "&"+hash+"=on"
		}
	}
	reload(address);
}

//On check on a checkbox of search file, memorise checked for refresh()
SharedSection.prototype.check_file = function(hash) {
	if(this.selected_file[hash] == true) {
		this.selected_file[hash] = false;
	} else {
		this.selected_file[hash] = true;
	}
}


// On refresh action
SharedSection.prototype.refresh = function(responseXML) {
	this.make_search_table(responseXML);
}

// On refresh search table of all found files
SharedSection.prototype.make_search_table = function(responseXML) {
	var file_list = responseXML.documentElement.getElementsByTagName("shared_file");
	var output = '\n<table><tr>\n';
	output += '\t<th class="checkbox" width="22" scope="col">&nbsp;</th>';
	output += '\t<th nowrap scope="col" onclick="javascript:Section.shortby(\'name\')" class="name"><div class="name" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Filename ('+file_list.length+')</div></th>\n';
	output += '\t<th nowrap scope="col" onclick="javascript:Section.shortby(\'xfer\')" class="xfer"><div class="xfer" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Transfered</div></th>\n';
	output += '\t<th nowrap scope="col" onclick="javascript:Section.shortby(\'req\')" class="req"><div class="req" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Requested</div></th>\n';
	output += '\t<th nowrap scope="col" onclick="javascript:Section.shortby(\'accept\')" class="accept"><div class="accept" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Accepted</div></th>\n';
	output += '\t<th nowrap scope="col" onclick="javascript:Section.shortby(\'size\')" class="size"><div class="size" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Size</div></th>\n';
	output += '\t<th nowrap scope="col" onclick="javascript:Section.shortby(\'prio\')" class="prio"><div class="prio" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Priority</div></th>\n';
	output += '</tr>\n';
	
	this.response_nb = file_list.length;
	// For each file
	for(i=0;i<file_list.length; i++) {
		var file = file_list.item(i);
		var hash = file.getElementsByTagName('hash').item(0).firstChild.data;
		if(this.selected_file[hash] != true) {
			this.selected_file[hash] = false;
		}
		
		output += '<tr oncontextmenu="Section.rightmenu_show(event, \''+ hash +'\')">\n';
		output += '\t<td><input type="checkbox" name="'+ hash +'" ';
		output += this.selected_file[hash]?'checked ':'';
		output += 'onclick=\'Section.check_file("'+hash+'")\' /></td>\n';
		output += '\t<td class="name" nowrap>'+ replace(file.getElementsByTagName('short_name').item(0).firstChild.data, " ", "&nbsp;") +'</td>\n';
		output += '\t<td>'+ file.getElementsByTagName('xfer').item(0).firstChild.data +'</td>\n';
		output += '\t<td>'+ file.getElementsByTagName('req').item(0).firstChild.data +'</td>\n';
		output += '\t<td>'+ file.getElementsByTagName('accept').item(0).firstChild.data +'</td>\n';
		output += '\t<td>'+ file.getElementsByTagName('size').item(0).firstChild.data +'</td>\n';
		output += '\t<td>'+ file.getElementsByTagName('prio').item(0).firstChild.data +'</td>\n';
		output += '</tr>\n';
	}
	output += '</table>\n';

	document.getElementById("shared_table").innerHTML = output;
}