function Transfert() {
	timer.set_delay(3);
	this.set_section();
	this.init_size();
	this.refresh_address = "ajax-dload.php";
	this.last_selects_update = 0;
	reload();
}


Transfert.prototype.set_section = function() {
	var output = '<div class="textline" id="transfert_dl_txt" name="transfert_dl_txt"><div id="transfert_dl_selects"></div><img src="arrow_down.gif" /> Download: ';
	output += '</div>';
	output += '<div id="transfert_dl" name="transfert_dl">Waiting for server reply...</div>';
	output += '<div class="textline" id="transfert_ul_txt" name="transfert_ul_txt"><img src="arrow_up.gif" /> Upload:</div>';
	output += '<div id="transfert_ul" name="transfert_ul">Waiting for server reply...</div>';
	
	document.getElementById("section").innerHTML = output;
}

// initialise div sizes (transfert_dl div)
Transfert.prototype.init_size = function() {
	var used_height = 0;
	used_height += document.getElementById("transfert_dl_txt").offsetHeight;
	used_height += document.getElementById("transfert_ul_txt").offsetHeight;
	used_height += document.getElementById("transfert_ul").offsetHeight;

	var resized_div = document.getElementById("transfert_dl");
	resized_div.style.height = document.getElementById("section").offsetHeight - used_height;
}

// show right menu on a file
Transfert.prototype.rightmenu_show = function(e, hash) {
	var rightmenu = document.getElementById("rightmenu");
	var output = '<div style="text-align: right; padding: 0px;"><img src="rm_close.gif" onclick="Section.rightmenu_hide()"/></div>';
	output += '<div class="rightmenuaction" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" onclick="Section.action(\'resume\',\''+hash+'\')"><img src="l_resume.gif" />Resume</div>';
	output += '<div class="rightmenuaction" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" onclick="Section.action(\'pause\',\''+hash+'\')"><img src="l_pause.gif" />Pause</div>';
	output += '<div class="rightmenuaction" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" onclick="Section.action(\'prioup\',\''+hash+'\')"><img src="l_up.gif" />Priority Up</div>';
	output += '<div class="rightmenuaction" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" onclick="Section.action(\'priodown\',\''+hash+'\')"><img src="l_down.gif" />Priority Down</div>';
	output += '<div class="rightmenuaction" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" onclick="Section.action(\'cancel\',\''+hash+'\')"><img src="l_cancel.gif" />Cancel</div>';

	if (!e) var e = window.event;
	if (e.pageX || e.pageY) 	{
		MouseX = e.pageX;
		MouseY = e.pageY;
	}
	else if (e.clientX || e.clientY) 	{
		MouseX = e.clientX + document.body.scrollLeft
			+ document.documentElement.scrollLeft;
		MouseY = e.clientY + document.body.scrollTop
			+ document.documentElement.scrollTop;
	}
	
	rightmenu.innerHTML = output;
	rightmenu.style.display = "block";
	rightmenu.style.top=MouseY;
	rightmenu.style.left=MouseX;

	return false;
}

// hide right menu on a file
Transfert.prototype.rightmenu_hide = function() {
	document.getElementById('rightmenu').style.display = 'none';
}

// transmit to server 'short by' query
Transfert.prototype.shortby_dl = function(criteria) {
	var address = "ajax-dload.php?sort="+criteria;
	reload(address);
}

// transmit to server 'short by' query
Transfert.prototype.shortby_ul = function(criteria) {
	//TODO but quite useless...
	//alert("sort by " + criteria);
}

// transmit to server action on file query
Transfert.prototype.action = function(action, hash) {
	this.rightmenu_hide();
	var address = "ajax-dload.php?command="+action+"&"+hash+"=on";
	if(action == "cancel") {
		if(!confirm("Are you sure to delete file?")) {
			return;
		}
	}
	reload(address);
}

// transmit to server filter by status query
Transfert.prototype.select_status = function(status) {
	var address = "ajax-dload.php?command=filter&status="+status;
	reload(address);
}

// transmit to server filter by category query
Transfert.prototype.select_categories = function(category) {
	var address = "ajax-dload.php?command=filter&category="+category;
	reload(address);
}

// On refresh action
Transfert.prototype.refresh = function(responseXML) {
	this.make_dl_table(responseXML);
	this.make_ul_table(responseXML);
	this.make_cat(responseXML);
}

// Draw the table of downloading files
Transfert.prototype.make_dl_table = function(responseXML) {
	var currentTime = new Date();
	//Refresh progress images all 30 seconds
	var refresh_time = Math.round(currentTime.getTime() / 30000);
	var dl_file_list = responseXML.documentElement.getElementsByTagName("dl_file");
	
	// Header
	output = "\n<table><tr>\n";
	output += '\t<th onclick="javascript:Section.shortby_dl(\'name\')" class="name"><div class="name" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Filename</div></th>\n';
	output += '\t<th onclick="javascript:Section.shortby_dl(\'size\')"><div class="size" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Size</div></th>\n';
	output += '\t<th onclick="javascript:Section.shortby_dl(\'speed\')"><div class="speed" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Speed</div></th>\n';
	output += '\t<th onclick="javascript:Section.shortby_dl(\'progress\')"><div class="progress" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'">Progress</div></th>\n';
	output += '\t<th onclick="javascript:Section.shortby_dl(\'src\')"><div class="src" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Source</div></th>\n';
	output += '\t<th onclick="javascript:Section.shortby_dl(\'status\')"><div class="status" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Status</div></th>\n';
	output += '\t<th onclick="javascript:Section.shortby_dl(\'prio\')"><div class="prio" onmouseover="this.style.background = \'white\'" onmouseout="this.style.background = \'#EEEEDD\'" >Priority</div></th>\n';
	output += '</tr>\n';
	
	// For each downloading file
	for(i=0;i<dl_file_list.length; i++) {
		var dl_file = dl_file_list.item(i);
		output += "<tr oncontextmenu=\"Section.rightmenu_show(event, '"+ dl_file.getElementsByTagName('hash').item(0).firstChild.data +"')\">\n";
		output += "\t<td class='name' nowrap>"+ replace(dl_file.getElementsByTagName('short_name').item(0).firstChild.data, " ", "&nbsp;") +"</td>\n";
		output += "\t<td>"+ dl_file.getElementsByTagName('size').item(0).firstChild.data +"</td>\n";
		output += "\t<td>"+ dl_file.getElementsByTagName('speed').item(0).firstChild.data +"</td>\n";
		output += "\t<td><img src='dyn_"+ dl_file.getElementsByTagName('hash').item(0).firstChild.data +".png?"+refresh_time+"' /></td>\n";
		output += "\t<td>"+ dl_file.getElementsByTagName('src_count').item(0).firstChild.data +"</td>\n";
		output += "\t<td>"+ dl_file.getElementsByTagName('status_string').item(0).firstChild.data +"</td>\n";
		output += "\t<td>"+ replace(dl_file.getElementsByTagName('prio').item(0).firstChild.data, " ", "&nbsp;") +"</td>\n";
		output += "</tr>\n";
	}
	document.getElementById("transfert_dl").innerHTML = output;
}

// Draw the table of uploading files
Transfert.prototype.make_ul_table = function(responseXML) {
	var ul_file_list = responseXML.documentElement.getElementsByTagName("ul_file");
	
	// Header
	output = "\n<table><tr>\n";
	output += "\t<th onclick=\"javascript:Section.shortby_ul('name')\"><div class='name'>Filename</div></th>\n";
	output += "\t<th onclick=\"javascript:Section.shortby_ul('user_name')\"><div class='user_name'>Username</div></th>\n";
	output += "\t<th onclick=\"javascript:Section.shortby_ul('speed')\"><div class='speed'>Speed</div></th>\n";
	output += "\t<th onclick=\"javascript:Section.shortby_ul('xfer_up')\"><div class='xfer_up'>Uploaded</div></th>\n";
	output += "\t<th onclick=\"javascript:Section.shortby_ul('xfer_down')\"><div class='xfer_down'>Downloaded</div></th>\n";
	output += "</tr>\n";
	
	// For each uploading file
	for(i=0;i<ul_file_list.length; i++) {
		var ul_file = ul_file_list.item(i);
		output += "<tr>\n";
		output += "\t<td class='name' nowrap>"+ replace(ul_file.getElementsByTagName('short_name').item(0).firstChild.data, " ", "&nbsp;") +"</td>\n";
		output += "\t<td nowrap>"+ replace(ul_file.getElementsByTagName('user_name').item(0).firstChild.data, " ", "&nbsp;") +"</td>\n";
		output += "\t<td>"+ ul_file.getElementsByTagName('speed').item(0).firstChild.data +"</td>\n";
		output += "\t<td>"+ ul_file.getElementsByTagName('xfer_up').item(0).firstChild.data +"</td>\n";
		output += "\t<td>"+ ul_file.getElementsByTagName('xfer_down').item(0).firstChild.data +"</td>\n";
		output += "</tr>\n";
	}
	document.getElementById("transfert_ul").innerHTML = output;
}

//Create select box for categories and status filters
Transfert.prototype.make_cat = function(responseXML) {
	var currentDate = new Date();
	var currentTime = currentDate.getTime();
	
	//only update all 30s
	if(this.last_selects_update + 30000 < currentTime ) {
		this.last_selects_update = currentTime;
		
		var categories = responseXML.documentElement.getElementsByTagName("categories").item(0);
		var cat_list = categories.getElementsByTagName("category");
		var cat_selected = categories.getElementsByTagName("selected").item(0).firstChild.data;
		
		var output = 'Category: <select name="selcategory" id="selcategory" onchange="Section.select_categories(this.options[this.selectedIndex].value)">\n';
		
		//Strange bug with category All in with localisation, so bypass first cat
		output += '<option value="all">all</option>\n';
		// For each category
		for(i=1;i<cat_list.length; i++) {
			var category = cat_list.item(i).firstChild.data;
			output += (cat_selected == category) ? '\t<option selected ' : '<option ';
			output += 'value="'+ category +'">' 
			output += category;
			output += '</option>\n';
		}
		output += '</select>\n';
		
		var all_status = new Array("all", "Waiting", "Paused", "Downloading");
		var status_selected = responseXML.documentElement.getElementsByTagName("filter_status").item(0).firstChild.data;
		
		output += ' Status: <select name="selstatus" id="selstatus" onchange="Section.select_status(this.options[this.selectedIndex].value)">\n';
		
		// For each status
	  for(i=0; i<all_status.length; i++) {
			output += (status_selected == all_status[i]) ? '\t<option selected ' : '<option ';
			output += 'value="'+ all_status[i] +'">' 
			output += all_status[i];
			output += '</option>\n';
		}
	  output += '</select>\n';
		
		document.getElementById("transfert_dl_selects").innerHTML = output;
	}
}
